#include <u.h>
#include <libc.h>
#include <ctype.h>
#include "httpd.h"
#include "httpsrv.h"

void
logit(HConnect *c, char *fmt, ...)
{
	char buf[4096];
	va_list arg;
	HSPriv *p;
	char *me;
	char *remote;
	char *q;

	va_start(arg, fmt);
	vseprint(buf, buf+sizeof(buf), fmt, arg);
	va_end(arg);
	p = nil;
	me = nil;
	if(c != nil){
		p = c->private;
		me = c->head.host;
	}
	if(!me)
		me = "-";
	/*	examples of "me":
	*	ar
	*	ar.aichi-u.ac.jp
	*	ar:8080
	*	ar.aichi-u.ac.jp:8080
	*	202.250.160.40
	*	202.250.160.40:8080	*/
	me = hstrdup(c, me);
	q = strchr(me,':');
	if(q)
		*q = 0;
	/*	we would like to extract last number if me is IP
	*	check the me is domname or IP
	*	the followings will work even if sysname is such as "a0"	*/
	if(isdigit(me[strlen(me) -1])){ // then we assume me is IP
		q= strrchr(me,'.');
		if(q)
			me = q+1;
	}
	else{
		q = strchr(me, '.');
		if(q)
			*q = 0;
	}
	remote = "none";
	if(p != nil && p->remotesys != nil)
		remote = p->remotesys;
	/*	port is assigned in httpd.c		*/
	if(strcmp(port, "80") != 0)
		syslog(0, HTTPLOG, "%d %s %s:%s %s", getpid(), remote, me, port, buf);
	else
		syslog(0, HTTPLOG, "%d %s %s %s", getpid(), remote, me, buf);
}
