#include <u.h>
#include <libc.h>
#include "httpd.h"
#include "misc.h"
#include "okip.h"

//#include "libhttpd/misc.h"

//int obstime = 30;
extern int obstime;
extern char *okip;

#ifdef XXX
/* defined in misc.c */
char *
skipto(char *s, char *p)
{
	while(*s && !strchr(p, *s))
		s++;
	return s;
}
#endif

void*
share(ulong len)
{
	uchar *mp;
	if((mp = segattach(0, "shared", 0, len)) == (void*)-1)
		return nil;
	return mp;
}

int
okchk(char *ip)
{
	char buf[OKSIZE];
	char *p, *p0, *q;
	long t0 = time(nil);
	/*	if /env/okip is absent then p0==nil	*/
	/*	format of p0
	*	"ip1,tm1 ip2,tm2 ..."
	*	where tm is time	*/
	strecpy(buf, buf + OKSIZE, okip);
	p0 = buf;
	while(p0){
		p = skipto(p0,",");
		if(*p != ',')
			break;
		*p++ = 0;
		q = skipto(p," ");
		*q++ = 0;
		if(strcmp(ip,p0) == 0 && t0 - atoi(p) < obstime)
			return 1;
		if(*q == 0)
			break;
		p0 = q;
	}
	return 0;
}

void
updateOkip(char *ip)
{
	char buf0[OKSIZE],buf1[OKSIZE];
	char *p0;
	char *s,*e,*p,*q;
	long t0 = time(nil);
	int f = 0; /* flag */
	/*
	* 	you may be prompted here to add some lock protection in changing okip.
	*	however we should consider whether it will be really worthwhile.
	*	if okip is broken, the ip or someone's ip will not be authorized to
	*	escape maxconnect check, and this is all the effect.
	*	next access will fix the okip.
	*/
	strecpy(buf0, buf0 + OKSIZE, okip);
	/*	we work on buf0 so that okip is not scratched */
	p0 = buf0;
	s = buf1;
	e = s + OKSIZE;
	while(p0){
		p = skipto(p0,",");
		if(*p != ',')
			break;
		*p++ = 0;
		q = skipto(p," ");
		*q++ = 0;
		if(strcmp(ip,p0) == 0){
			s = seprint(s,e,"%s,%d ", p0, t0);
			f = 1;
		}
		else if(t0 - atoi(p) < obstime)
			s = seprint(s,e,"%s,%s ", p0, p);
		if(*q == 0)
			break;
		p0 = q;
	}
	if(!f)
		s = seprint(s,e,"%s,%d ", ip, t0);
	*--s = 0;
	strecpy(okip,okip + OKSIZE, buf1);
}

#ifdef XXX
void
main(int argc, char *argv[])
{
	char *e = nil;
	ARGBEGIN{
	case 'e':
		e = ARGF();
		break;
	default: break;
	}ARGEND
	
	while(*argv)
		updateOkip(*argv++);
	if(e)
		print("%d\n",okchk(e));
}
#endif
