#include <u.h>
#include <libc.h>
#include <ctype.h>
#include "httpd.h"
#include "httpsrv.h"

typedef struct ChunkBuf ChunkBuf;
struct ChunkBuf
{
	uchar	buf[Hsize+32];
	int	size;
	ChunkBuf *next;
};

/*	What will happen if post data size is not same as c->head.contlen ?
*	Important but I haven't the answer yet.
*	Need experiment!
*	-Kenar-	*/

int
acceptpost(HConnect *c, int maxpost)
{
	int fd[2];
	char *hb;
	Hio *hin;
	ChunkBuf *cb, *cb0, *cb1;
	int m,n;


	if(c->head.contlen > maxpost){
		logit(c, "error: post data too large: %d", c->head.contlen);
		hfail(c, HReqSize, maxpost);
		return -1;
	}
	/*	What should I do if head.contlen is not same as size of real data.
	*	Protections is needed	*/
	hin = hbodypush(&c->hin, c->head.contlen, c->head.transenc);
	if(hin == nil){
		logit(c, "error: nil hbodypush");
		hfail(c, HInternal);
		return -1;
	}
	m = 0;
	cb0 = cb = nil;
	for(; hb = hreadbuf(hin, hin->pos); hin->pos = hin->stop){
		cb1 = malloc(sizeof *cb1);
		if(cb1 == nil){
			logit(c, "error: nil malloc ChunkBuf");
			hfail(c, HInternal);
			return -1;
		}
		n = hbuflen(hin, hb);
		//logit(c,"DBG: post %d + %d",m,n);
		memcpy(cb1->buf, hb, n);
		cb1->size = n;
		m += n;
		if(m > maxpost){
			logit(c, "error: post data too large: %d", c->head.contlen);
			hfail(c, HReqSize, maxpost);
			return -1;
		}
		if(cb0 == nil)
			cb0 = cb1;
		if(cb != nil)
			cb->next = cb1;
		cb = cb1;
	}
/*
	if(cb == nil){
		hfail(c, HBadReq);
		return -1;
	}
	cb->next = nil;
*/
	if(cb != nil)
		cb->next = nil;

	logit(c, "post %d bytes", m);
    c->head.contlen = m; // we need reflesh contlen



	/* pass the hb to exec() */
	pipe(fd);
	switch(fork()){
	case -1:
		logit(c, "error: fork # %r");
		hfail(c, HInternal);
		return -1;
	case 0:
		/*	Let the child exit, because I would like to let CGI
		*	succeed to this pid
		*	-Kenar-	*/
		close(0);
		close(fd[0]);
		dup(fd[1], 1);
		close(fd[1]);
		/*	POST data have been received in ChunkBuf cb0,
		*	so we pass the data to the child process */

		cb = cb0;
		while(cb){
			m=write(1, cb->buf, cb->size);
			if(m != cb->size){
				logit(c, "error: write # %r");
				hfail(c, HInternal);
			}
			cb = cb->next;
		}
		exits(nil);
	default:
		close(fd[1]);
		dup(fd[0], 0);
		close(fd[0]);
		/* remove ChunkBuf pointed by cb0 */
		cb = cb0;
		while(cb){
			cb1 = cb->next;
			free(cb);
			cb = cb1;
		}
		break;
	}
	return 0;
}
